//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#pragma link "AbOpPnt"
#pragma link "AbMTrend"
#pragma link "AbTrend"
#pragma link "AbLabel"
#pragma link "AbVCInd"
#pragma link "AbClock"
#pragma link "AbBar"
#pragma link "AbVBar"
#pragma link "AbHBar"
#pragma link "AbThMet"
#pragma link "AbVMeter"
#pragma link "AbHMeter"
#pragma link "AbRMeter"
#pragma link "AbCompas"
#pragma link "AbGearDial"
#pragma link "AbHSlide"
#pragma link "AbVSlide"
#pragma link "AbCompas"
#pragma link "AbOpHour"
#pragma link "AbSwitch"
#pragma link "AbLED"
#pragma link "AbDial"
#pragma link "AbTank"
#pragma link "AbCBitBt"
#pragma link "AbVInd"

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  DeleteAllBtnClick(this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
  int n, nn;
  TComponent *cmp;
  for (n=ComponentPanel->ComponentCount-1; n>=0; n--) {
    cmp = ComponentPanel->Components[n];
    if (dynamic_cast<TAbOperatingPoint*> (cmp)) {
      Randomize();
      ((TAbOperatingPoint*)cmp)->ValueX = ScrollBar1->Position/10;
      ((TAbOperatingPoint*)cmp)->ValueY = 40 + ScrollBar1->Position/17 + random(5);
    } else if (dynamic_cast<TAbMiniTrend*> (cmp)) {
      ((TAbMiniTrend*)cmp)->DigitCh1 = ScrollBar1->Position;
      ((TAbMiniTrend*)cmp)->DigitCh2 = 1000-ScrollBar1->Position;
    } else if (dynamic_cast<TAbTrend*> (cmp)) {
        ((TAbTrend*)cmp)->Channel1->Value = ScrollBar1->Position ;
        ((TAbTrend*)cmp)->Channel2->Value = ScrollBar1->Position / 2;
        ((TAbTrend*)cmp)->Channel3->Value = ScrollBar1->Position / 3;
        ((TAbTrend*)cmp)->Channel4->Value = ScrollBar1->Position / 4;
        ((TAbTrend*)cmp)->Channel5->Value = ScrollBar1->Position / 5;
        ((TAbTrend*)cmp)->Channel6->Value = ScrollBar1->Position / 6;
        ((TAbTrend*)cmp)->Channel7->Value = ScrollBar1->Position / 7;
        ((TAbTrend*)cmp)->Channel8->Value = ScrollBar1->Position / 7;
    }else if (dynamic_cast<TAbLabel*> (cmp)) {
      ((TAbLabel*)cmp)->Digit = ScrollBar1->Position / 100;
    } else if (dynamic_cast<TAbAnalogCControl*> (cmp)) {
      ((TAbAnalogCControl*)cmp)->Digit = ScrollBar1->Position;
    } else if (dynamic_cast<TAbVCInd*> (cmp)) {
      ((TAbVCInd*)cmp)->Course = ScrollBar1->Position * 0.36;
      ((TAbVCInd*)cmp)->CourseShould = -ScrollBar1->Position * 0.36;
      ((TAbVCInd*)cmp)->Pitch = (ScrollBar1->Position-500) * 0.36;
      ((TAbVCInd*)cmp)->Roll = (ScrollBar1->Position-500) * 0.09;
    } else if (dynamic_cast<TAbAnalogGControl*> (cmp)) {
      ((TAbAnalogGControl*)cmp)->Digit = ScrollBar1->Position;
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BinStatus_CheckBoxClick(TObject *Sender)
{
  int n;
  TComponent *cmp;

  for (n=ComponentPanel->ComponentCount-1; n>=0; n--) {
    cmp = ComponentPanel->Components[n];
    if (dynamic_cast<TAbBinGControl*> (cmp))
       ((TAbBinGControl*)cmp)->Checked = BinStatus_CheckBox->Checked;
    else if (dynamic_cast<TAbAnalogGControl*> (cmp))
       ((TAbAnalogGControl*)cmp)->MinMax->MinVisible = BinStatus_CheckBox->Checked;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DeleteAllBtnClick(TObject *Sender)
{
  for (int n=ComponentPanel->ComponentCount-1; n>=0; n--)
    ComponentPanel->Components[n]->Free();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  TAbClock *clock;
  TAbBar *bar;
  TAbValueInd *vind;
  TAbVBar *vbar;
  TAbHBar *hbar;
  TAbTank *tank;
  TAbThermometer *tempmeter;
  TAbVMeter *vmeter;
  TAbHMeter *hmeter;
  TAb120Meter *r120meter;
  TAb180Meter *r180meter;
  TAb270Meter *r270meter;
  TAbCompass *compass;
  TAbVCInd *vcind;
  TAbOperatingPoint *oppoint;
  TAbMiniTrend *mtrend;
  TAbTrend *trend;
  TAbGearDial *gdial;
  TAbDial *dial;
  TAbHSlider *hslide;
  TAbVSlider *vslide;
  TAbLED *led;
  TAbColBitBtn *cbitbtn;
  TAbRockerSwitch *rswitch;
  TAbToggleSwitch *tswitch;
  TAbOpHourCounter *ophcounter;
  TAbLabel *alabel;

  if (ClockBtn->Down) {
    clock = new TAbClock(ComponentPanel);
    clock->Parent = ComponentPanel;
    clock->Left = X;
    clock->Top = Y;
    clock->Loaded();
  } else if (VIndBtn->Down) {
    vind  = new TAbValueInd(ComponentPanel);
    vind->Parent = ComponentPanel;
    vind->Left = X;
    vind->Top = Y;
    vind->Loaded();
  } else if (BarBtn->Down) {
    bar = new TAbBar(ComponentPanel);
    bar->Parent = ComponentPanel;
    bar->Left = X;
    bar->Top = Y;
    bar->Loaded();
  } else if (VBarBtn->Down) {
    vbar  = new TAbVBar(ComponentPanel);
    vbar->Parent = ComponentPanel;
    vbar->Left = X;
    vbar->Top = Y;
    vbar->Loaded();
  } else if (HBarBtn->Down) {
    hbar  = new TAbHBar(ComponentPanel);
    hbar->Parent = ComponentPanel;
    hbar->Left = X;
    hbar->Top = Y;
    hbar->Loaded();
  } else if (TankBtn->Down) {
    tank  = new TAbTank(ComponentPanel);
    tank->Parent = ComponentPanel;
    tank->Left = X;
    tank->Top = Y;
    tank->Loaded();
  } else if (TempMeterBtn->Down) {
    tempmeter  = new TAbThermometer(ComponentPanel);
    tempmeter->Parent = ComponentPanel;
    tempmeter->Left = X;
    tempmeter->Top = Y;
    tempmeter->Loaded();
  } else if (VMeterBtn->Down) {
    vmeter  = new TAbVMeter(ComponentPanel);
    vmeter->Parent = ComponentPanel;
    vmeter->Left = X;
    vmeter->Top = Y;
    vmeter->Loaded();
  } else if (HMeterBtn->Down) {
    hmeter  = new TAbHMeter(ComponentPanel);
    hmeter->Parent = ComponentPanel;
    hmeter->Left = X;
    hmeter->Top = Y;
    hmeter->Loaded();
  } else if (r120MeterBtn->Down) {
    r120meter  = new TAb120Meter(ComponentPanel);
    r120meter->Parent = ComponentPanel;
    r120meter->Left = X;
    r120meter->Top = Y;
    r120meter->Loaded();
  } else if (r180MeterBtn->Down) {
    r180meter  = new TAb180Meter(ComponentPanel);
    r180meter->Parent = ComponentPanel;
    r180meter->Left = X;
    r180meter->Top = Y;
    r180meter->Loaded();
  } else if (r270MeterBtn->Down) {
    r270meter  = new TAb270Meter(ComponentPanel);
    r270meter->Parent = ComponentPanel;
    r270meter->Left = X;
    r270meter->Top = Y;
    r270meter->Loaded();
  } else if (CompassBtn->Down) {
    compass  = new TAbCompass(ComponentPanel);
    compass->Parent = ComponentPanel;
    compass->Left = X;
    compass->Top = Y;
    compass->Loaded();
  } else if (VCIndBtn->Down) {
    vcind  = new TAbVCInd(ComponentPanel);
    vcind->Parent = ComponentPanel;
    vcind->Left = X;
    vcind->Top = Y;
    vcind->Loaded();
  } else if (OpPointBtn->Down) {
    oppoint  = new TAbOperatingPoint(ComponentPanel);
    oppoint->Parent = ComponentPanel;
    oppoint->CharacteristicBMP = Image1->Picture->Bitmap;
    oppoint->IndRect->SetxyRect(Rect(35,21,335,346));
    oppoint->Interval = 200;
    oppoint->Left = X;
    oppoint->Top = Y;
    oppoint->Loaded();
  } else if (MTrendBtn->Down) {
    mtrend  = new TAbMiniTrend(ComponentPanel);
    mtrend->Parent = ComponentPanel;
    mtrend->Left = X;
    mtrend->Top = Y;
    mtrend->Loaded();
  } else if (TrendBtn->Down) {
    trend  = new TAbTrend(ComponentPanel);
    trend->Parent = ComponentPanel;
    trend->Left = X;
    trend->Top = Y;
    trend->Options = trend->Options >> opCursorOnRec;
    trend->Interval = 100;
    trend->Loaded();
    trend->StartRecording = True;
  } else if (GDialBtn->Down) {
    gdial = new TAbGearDial(ComponentPanel);
    gdial->Parent = ComponentPanel;
    gdial->Parent = ComponentPanel;
    gdial->Left = X;
    gdial->Top  = Y;
    gdial->Loaded();
    gdial->OnValueChange = AdjusterValueChange;
  } else if (DialBtn->Down) {
    dial  = new TAbDial(ComponentPanel);
    dial->Parent = ComponentPanel;
    dial->Parent = ComponentPanel;
    dial->Left = X;
    dial->Top  = Y;
    dial->Loaded();
    dial->OnValueChange = AdjusterValueChange;
  } else if (HSlideBtn->Down) {
    hslide  = new TAbHSlider(ComponentPanel);
    hslide->Parent = ComponentPanel;
    hslide->Left = X;
    hslide->Top  = Y;
    hslide->Loaded();
    hslide->OnValueChange = AdjusterValueChange;
  } else if (VSlideBtn->Down) {
    vslide  = new TAbVSlider(ComponentPanel);
    vslide->Parent = ComponentPanel;
    vslide->Left = X;
    vslide->Top  = Y;
    vslide->Loaded();
    vslide->OnValueChange = AdjusterValueChange;
  } else if (LEDBtn->Down) {
    led  = new TAbLED(ComponentPanel);
    led->Parent = ComponentPanel;
    led->Caption = "LED";
    led->Left = X;
    led->Top = Y;
    led->OnStatusChanged = BinStatusChange;
    //led->Loaded();
  } else if (ColBitBtn->Down) {
    cbitbtn  = new TAbColBitBtn(ComponentPanel);
    cbitbtn->Parent = ComponentPanel;
    cbitbtn->Left = X;
    cbitbtn->Top = Y;
    cbitbtn->Loaded();
    cbitbtn->OnStatusChanged = BinStatusChange;
  } else if (RockerSwitchBtn->Down) {
    rswitch  = new TAbRockerSwitch(ComponentPanel);
    rswitch->Parent = ComponentPanel;
    rswitch->Left = X;
    rswitch->Top = Y;
    rswitch->Loaded();
    rswitch->OnStatusChanged = BinStatusChange;
  } else if (tSwitchBtn->Down) {
    tswitch  = new TAbToggleSwitch(ComponentPanel);
    tswitch->Parent = ComponentPanel;
    tswitch->Left = X;
    tswitch->Top = Y;
    tswitch->Loaded();
    tswitch->OnStatusChanged = BinStatusChange;
  } else if (OpHCountBtn->Down) {
    ophcounter  = new TAbOpHourCounter(ComponentPanel);
    ophcounter->Parent = ComponentPanel;
    ophcounter->Left = X;
    ophcounter->Top = Y;
    ophcounter->Loaded();
    ophcounter->Count = True;
  } else if (LabelBtn->Down) {
    alabel  = new TAbLabel(ComponentPanel);
    alabel->Parent = ComponentPanel;
    alabel->Left = X;
    alabel->Top = Y;
    alabel->DigitText = "0..99;100..199;200..299;300..399;400..499;500..599;600..699;700..799;800..899;900..999";
    alabel->DefaultText = "max.";
  }
  DefaultBtn->Down = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ResetMinMaxClick(TObject *Sender)
{
  int n;
  TComponent *cmp;
  for (n = ComponentPanel->ComponentCount-1; n>=0; n--) {
    cmp = ComponentPanel->Components[n];
    if (dynamic_cast<TAbAnalogGControl*> (cmp))
       ((TAbAnalogGControl*)cmp)->ResetMinMax();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BinStatusChange(TObject *Sender)
{
  if (dynamic_cast<TAbBinGControl*> (Sender))
     BinStatus_CheckBox->Checked = ((TAbBinGControl*)Sender)->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AdjusterValueChange(TObject *Sender)
{
  if (dynamic_cast<TAbAnalogCControl*> (Sender))
     ScrollBar1->Position = ((TAbAnalogCControl*)Sender)->Digit;
}
//---------------------------------------------------------------------------

