//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "_AbGradient.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "_GClass"
#pragma link "AbGradient"
#pragma resource "*.dfm"
TAbGradientForm *AbGradientForm;
//---------------------------------------------------------------------------
__fastcall TAbGradientForm::TAbGradientForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void TAbGradientForm::SetGradientColors()
{
  TComponent *cmp;
  // change colors for all TAbGradient components
  for (int n=0; n<ComponentCount; n++) {
    cmp = Components[n];
    if (dynamic_cast<TAbGradient*> (cmp)) {
        TAbGradient *grad = (TAbGradient*)cmp;
        grad->BeginUpdate();
        grad->GradSettings->ColorFrom = ColorFromShape->Brush->Color;
        grad->GradSettings->ColorTo   = ColorToShape->Brush->Color;
        grad->EndUpdate();
    }
  }
}

void __fastcall TAbGradientForm::ColorFromBtnClick(TObject *Sender)
{
  ColorDialog1->Color = ColorFromShape->Brush->Color;
  if (ColorDialog1->Execute())
    ColorFromShape->Brush->Color = ColorDialog1->Color;
  SetGradientColors();
}
//---------------------------------------------------------------------------
void __fastcall TAbGradientForm::ColorToBtnClick(TObject *Sender)
{
  ColorDialog1->Color = ColorToShape->Brush->Color;
  if (ColorDialog1->Execute())
     ColorToShape->Brush->Color = ColorDialog1->Color;
  SetGradientColors();
}
//---------------------------------------------------------------------------
