unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AbMask, _AbProc, _GClass, AbVSlide, StdCtrls;

//==============================================================================
//       in this demo some Abakus methods are used....
//      you have to add unit "_AbProc" to uses...
//==============================================================================


type
  TForm1 = class(TForm)
    AbBMaskMeter1: TAbBMaskMeter;
    AbVSlider1: TAbVSlider;
    AbBMaskMeter2: TAbBMaskMeter;
    AbBMaskMeter3: TAbBMaskMeter;
    AbBMaskMeter4: TAbBMaskMeter;
    Label1: TLabel;
    procedure AbBMaskMeter1Change(can: TCanvas);
    procedure AbVSlider1ValueChange(Sender: TObject);
    procedure AbBMaskMeter4Change(can: TCanvas);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses Types;

{$R *.dfm}

procedure TForm1.AbBMaskMeter1Change(can: TCanvas);
var
  w, h, cpos : Integer;
  rValue     : TRect;
  bmp        : TBitmap;
begin

  // width and height of the user canvas "can"
  w := can.ClipRect.Right;
  h := can.ClipRect.Bottom;

  // gradient fill for the total background
  AbGradFill(can, can.ClipRect, clWhite, RGB(50,50,50), gsHorizontal3);

  // create a temp bitmap for the level
  bmp := TBitmap.Create;
  bmp.Width := w;
  bmp.Height := h;

  AbGradFill(bmp.Canvas, bmp.Canvas.ClipRect, clAqua, clNavy, gsHorizontal3);

  // acording the actual Value in PPH copy only the part from bottom until
  // current level to the User-Canvas "can"
  cpos   := Round((h/100)*AbBMaskMeter1.PPH);
  rValue := Rect(0,h-cpos,w,h);
  can.CopyRect(rValue, bmp.Canvas, rValue);

  bmp.Free;

end;

procedure TForm1.AbVSlider1ValueChange(Sender: TObject);
begin
  AbBMaskMeter1.Value := AbVSlider1.Value;
  AbBMaskMeter2.Value := AbVSlider1.Value;
  AbBMaskMeter4.Value := AbVSlider1.Value;

  // change the color accordin Slider value
  AbBMaskMeter3.ColForeground := AbCalcColor(clMaroon, clRed, 100, Round(AbVSlider1.Value));
end;


procedure TForm1.AbBMaskMeter4Change(can: TCanvas);
var
  w, h, cpos : Integer;
  rValue     : TRect;
  bmp        : TBitmap;
  i : Integer;
begin

  // width and height of the user canvas "can"
  w := can.ClipRect.Right;
  h := can.ClipRect.Bottom;

  // gradient fill for the total background
  AbGradFill(can, can.ClipRect, clWhite, RGB(50,50,50), gsVertical1);

  // create a temp bitmap for the level
  bmp := TBitmap.Create;
  bmp.Width := w;
  bmp.Height := h;

  AbGradFill(bmp.Canvas, bmp.Canvas.ClipRect, clAqua, clNavy, gsVertical3);

  // acording the actual Value in PPH copy only the part from bottom until
  // current level to the User-Canvas "can"
  cpos   := Round((h/100)*AbBMaskMeter4.PPH);
  rValue := Rect(0,h-cpos,w,h);
  can.CopyRect(rValue, bmp.Canvas, rValue);

  can.Brush.Color := clAqua;
  can.Brush.Style := bsSolid;
  can.Pen.Color   := clBlue;

  // the bottle becomes smaller above 60%
  if AbBMaskMeter4.PPH < 60 then begin
     i := 10;
  end else begin
     i := 10 - Round((AbBMaskMeter4.PPH-60)/4);
  end;
  can.Ellipse(10-i,h-cpos-i, w-(10-i), (h-cpos)+i);

  bmp.Free;

end;


end.
