//---------------------------------------------------------------------------
#include <vcl.h>
#include <printers.hpp>
#pragma hdrstop

#include "_AbTrend.h"
#include "_AbPrintTrend.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "AbPrtTrd"
#pragma resource "*.dfm"
TAbPrintTrendForm *AbPrintTrendForm;
//---------------------------------------------------------------------------
__fastcall TAbPrintTrendForm::TAbPrintTrendForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TAbPrintTrendForm::ZoomComboBoxChange(TObject *Sender)
{
  LandscapeAbPrintTrend->PreviewZoom = StrToInt(ZoomComboBox->Text) /100;
}
//---------------------------------------------------------------------------
void __fastcall TAbPrintTrendForm::LandscapeButtonClick(TObject *Sender)
{
  if (PrintDialog1->Execute()) {
    Printer()->Title = "PrintTrend-Demo";
    Printer()->Orientation = poLandscape;
    LandscapeAbPrintTrend->PrintTrend(100,50);
  }
}
//---------------------------------------------------------------------------
void __fastcall TAbPrintTrendForm::PortraitButtonClick(TObject *Sender)
{
  if (PrintDialog1->Execute()) {
    Printer()->Title = "PrintTrend-Demo";
    Printer()->Orientation = poPortrait;
    Printer()->BeginDoc();
    PortraitAbPrintTrend->ExPrintTrend(50,50);
    PortraitAbPrintTrend->ExPrintTrend(50,1450);
    Printer()->EndDoc();
  }
}
//---------------------------------------------------------------------------
void __fastcall TAbPrintTrendForm::ColorCheckBoxClick(TObject *Sender)
{
  if (ColorCheckBox->Checked)
    PortraitAbPrintTrend->Options = PortraitAbPrintTrend->Options << ptColor;
  else
    PortraitAbPrintTrend->Options = PortraitAbPrintTrend->Options >> ptColor;

  if (ColorCheckBox->Checked)
    LandscapeAbPrintTrend->Options = LandscapeAbPrintTrend->Options << ptColor;
  else
    LandscapeAbPrintTrend->Options = LandscapeAbPrintTrend->Options >> ptColor;

}
//---------------------------------------------------------------------------
void __fastcall TAbPrintTrendForm::FormCreate(TObject *Sender)
{
  ZoomComboBox->ItemIndex = 6;
  PortraitAbPrintTrend->RecFrom = AbTrendForm->AbTrend1->RecordInfo->FirstDisplayedRec;
  PortraitAbPrintTrend->RecTo = AbTrendForm->AbTrend1->RecordInfo->LastDisplayedRec;
}
//---------------------------------------------------------------------------
