//---------------------------------------------------------------------------
#ifndef _AbPrintTrendH
#define _AbPrintTrendH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "AbPrtTrd.hpp"
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TAbPrintTrendForm : public TForm
{
__published:	// Komponenten, die von der IDE verwaltet werden
    TPanel *Panel1;
    TLabel *Label1;
    TLabel *Label2;
    TComboBox *ZoomComboBox;
    TButton *LandscapeButton;
    TButton *PortraitButton;
    TCheckBox *ColorCheckBox;
    TMemo *Memo1;
    TScrollBox *ScrollBox1;
    TPaintBox *PaintBox1;
    TAbPrintTrend *LandscapeAbPrintTrend;
    TAbPrintTrend *PortraitAbPrintTrend;
    TPrintDialog *PrintDialog1;
    void __fastcall ZoomComboBoxChange(TObject *Sender);
    void __fastcall LandscapeButtonClick(TObject *Sender);
    void __fastcall PortraitButtonClick(TObject *Sender);
    void __fastcall ColorCheckBoxClick(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
private:	// Benutzerdeklarationen
public:		// Benutzerdeklarationen
    __fastcall TAbPrintTrendForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TAbPrintTrendForm *AbPrintTrendForm;
//---------------------------------------------------------------------------
#endif
