unit Unit1;

{ XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
   Abakus VCL, common timer demo
   =============================
   This project show's how to use our common Timer with the methods
        WM_FLASH - MESSAGE_HANDLER, AddControl, DelControl
   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  AbFlashT;      // Add flashtimer unit

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    procedure CheckBox1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure WMFlash(var Message: TMessage); message WM_FLASH;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if Checkbox1.Checked then
    AddControl(Form1, 500)      { <--- call "AbFlashProc" all 500ms
     to change the Time youst call AddProc with the new time again
     - time-values < 50 are used internaly
     - for synchronized Flashing use const.
                        "Freq05Hz, Freq1Hz, Freq2Hz, Freq4Hz or Freq8Hz"  }
  else
    DelControl(Form1);          // <--- stop "YourFlashMethod" call's
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DelControl(Form1);            // <--- stop "YourFlashMethod" call's
end;

procedure TForm1.WMFlash(var Message: TMessage);
begin
 { XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
   WParam: times our timer is called since start
   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
   Checkbox2.Checked := not Checkbox2.Checked;
end;


end.
