unit _AbSpinBtn;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, _GClass, AbLED;

type
  TAbSpinBtnForm = class(TForm)
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    AbSpinButton1: TAbSpinButton;
    AbSpinButton2: TAbSpinButton;
    AbSpinButton3: TAbSpinButton;
    Memo1: TMemo;
    OnUpClickLED: TAbLED;
    OnDownClickLED: TAbLED;
    Label1: TLabel;
    EnableUpCheckBox: TCheckBox;
    EnableDownCheckBox: TCheckBox;
    AbSpinButton4: TAbSpinButton;
    procedure AbSpinButton1DownClick(Sender: TObject);
    procedure AbSpinButton1UpClick(Sender: TObject);
    procedure EnableUpCheckBoxClick(Sender: TObject);
    procedure EnableDownCheckBoxClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  AbSpinBtnForm: TAbSpinBtnForm;

implementation

{$R *.DFM}

procedure TAbSpinBtnForm.AbSpinButton1DownClick(Sender: TObject);
begin
  OnDownClickLED.Checked := not OnDownClickLED.Checked;
end;

procedure TAbSpinBtnForm.AbSpinButton1UpClick(Sender: TObject);
begin
  OnUpClickLED.Checked := not OnUpClickLED.Checked;
end;

procedure TAbSpinBtnForm.EnableUpCheckBoxClick(Sender: TObject);
begin
  AbSpinButton2.FUpButton.Enabled := EnableUpCheckBox.Checked;
  AbSpinButton3.FUpButton.Enabled := EnableUpCheckBox.Checked;
end;

procedure TAbSpinBtnForm.EnableDownCheckBoxClick(Sender: TObject);
begin
  AbSpinButton2.FDownButton.Enabled := EnableDownCheckBox.Checked;
  AbSpinButton3.FDownButton.Enabled := EnableDownCheckBox.Checked;
end;

procedure TAbSpinBtnForm.FormShow(Sender: TObject);
begin
  AbSpinButton4.FUpButton.Caption := 'INC';
  AbSpinButton4.FDownButton.Caption := 'DEC';
end;

end.
