unit _AbTimerSpeedBtn;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, _GClass, AbOpPnt, AbLED;

type
  TAbTimerSpeedBtnForm = class(TForm)
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    AbTimerSpeedBtn1: TAbTimerSpeedBtn;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    UpBtn: TAbTimerSpeedBtn;
    UpRightBtn: TAbTimerSpeedBtn;
    LeftBtn: TAbTimerSpeedBtn;
    AbTimerSpeedBtn5: TAbTimerSpeedBtn;
    UpLeftBtn: TAbTimerSpeedBtn;
    RightBtn: TAbTimerSpeedBtn;
    DownLeftBtn: TAbTimerSpeedBtn;
    Down: TAbTimerSpeedBtn;
    DownRight: TAbTimerSpeedBtn;
    AbOperatingPoint1: TAbOperatingPoint;
    Memo1: TMemo;
    OnClickLED: TAbLED;
    procedure MoveBtnClick(Sender: TObject);
    procedure AbTimerSpeedBtn5Click(Sender: TObject);
    procedure AbTimerSpeedBtn1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  AbTimerSpeedBtnForm: TAbTimerSpeedBtnForm;

implementation

{$R *.DFM}

procedure TAbTimerSpeedBtnForm.MoveBtnClick(Sender: TObject);
var
  cmpName : String;
  vx,vy : Integer;
begin

  cmpName := (Sender as TComponent).Name;

  vx := AbOperatingPoint1.DigitX;
  vy := AbOperatingPoint1.DigitY;

  if (Pos('Left', cmpName) >0) then Dec(vx)
  else if (Pos('Right', cmpName) >0) then Inc(vx);

  if (Pos('Up', cmpName) >0) then Inc(vy)
  else if (Pos('Down', cmpName) >0) then Dec(vy);

  if vx < 0 then vx := 0 else if vx > 100 then vx := 100;
  if vy < 0 then vy := 0 else if vy > 100 then vy := 100;

  AbOperatingPoint1.DigitX := vx;
  AbOperatingPoint1.DigitY := vy;
end;

procedure TAbTimerSpeedBtnForm.AbTimerSpeedBtn5Click(Sender: TObject);
begin
  AbOperatingPoint1.DigitX := 50;
  AbOperatingPoint1.DigitY := 50;
end;

procedure TAbTimerSpeedBtnForm.AbTimerSpeedBtn1Click(Sender: TObject);
begin
  OnClickLED.Checked := not OnClickLED.Checked;
end;

end.
